Index: cpp/frams/genetics/f4/f4_general.cpp
===================================================================
--- cpp/frams/genetics/f4/f4_general.cpp	(revision 1226)
+++ cpp/frams/genetics/f4/f4_general.cpp	(revision 1227)
@@ -1018,7 +1014,7 @@
 
 	// neurons attached to it
-	for (i = 0; i < nc; i++)
-	{
-		if (C[i]->type == T_NEURON4)
+	for (i = 0; i < cell_count; i++)
+	{
+		if (C[i]->type == CELL_NEURON)
 		{
 			if (C[i]->dadlink == thisti)
@@ -1027,23 +1023,16 @@
 				out += "[";
 				// ctrl
-				if (1 == thneu->ctrl) out += "@";
-				if (2 == thneu->ctrl) out += "|";
-				// links
-				for (j = 0; j < thneu->nolink; j++)
+				//if (1 == thneu->ctrl) out += "@"; // old code; this can be easily generalized to any neuroclass if ever needed
+				//if (2 == thneu->ctrl) out += "|";
+				out += thneu->neuclass->name.c_str(); // not tested, but something like that
+				// connections
+				for (j = 0; j < thneu->conns_count; j++)
 				{
 					if (j) out += ",";
-					if (NULL == thneu->links[j]->from)
-					{
-						// sensors
-						out += thneu->links[j]->t.c_str();
-					}
-					else
-					{
-						sprintf(buf, "%d", thneu->links[j]->from->name - thneu->name);
-						out += buf;
-					}
+					sprintf(buf, "%d", thneu->conns[j]->from->nr - thneu->nr);
+					out += buf;
 					out += ":";
 					// connection weight
-					sprintf(buf, "%g", thneu->links[j]->w);
+					sprintf(buf, "%g", thneu->conns[j]->weight);
 					out += buf;
 				}
@@ -1058,7 +1047,7 @@
 
 	ccount = 1;
-	for (i = 0; i < nc; i++)
-	{
-		if (C[i]->type == T_STICK4)
+	for (i = 0; i < cell_count; i++)
+	{
+		if (C[i]->type == CELL_STICK)
 		{
 			if (C[i]->dadlink == thisti)
@@ -1088,5 +1077,5 @@
 // to organize an f4 genotype in a tree structure
 
-f4_node::f4_node()
+f4_Node::f4_Node()
 {
 	name = "?";
@@ -1095,10 +1084,14 @@
 	child2 = NULL;
 	pos = -1;
-	l1 = 0;
-	i1 = 0;
-	f1 = 0.0f;
-}
-
-f4_node::f4_node(string nname, f4_node *nparent, int npos)
+
+	reps = 0;
+	prop_symbol = '\0';
+	prop_increase = false;
+	conn_from = 0;
+	conn_weight = 0.0;
+	neuclass = NULL;
+}
+
+f4_Node::f4_Node(string nname, f4_Node *nparent, int npos)
 {
 	name = nname;
@@ -1108,10 +1101,14 @@
 	pos = npos;
 	if (parent) parent->addChild(this);
-	l1 = 0;
-	i1 = 0;
-	f1 = 0.0f;
-}
-
-f4_node::f4_node(char nname, f4_node *nparent, int npos)
+
+	reps = 0;
+	prop_symbol = '\0';
+	prop_increase = false;
+	conn_from = 0;
+	conn_weight = 0.0;
+	neuclass = NULL;
+}
+
+f4_Node::f4_Node(char nname, f4_Node *nparent, int npos)
 {
 	name = nname;
@@ -1121,25 +1118,37 @@
 	pos = npos;
 	if (parent) parent->addChild(this);
-	l1 = 0;
-	i1 = 0;
-	f1 = 0.0f;
-}
-
-f4_node::~f4_node()
-{
-	// (destroy() copied here for efficiency)
-	// children are destroyed (recursively) through the destructor
-	if (NULL != child2)  delete child2;
-	if (NULL != child)   delete child;
-}
-
-int f4_node::addChild(f4_node *nchi)
-{
-	if (NULL == child)
+
+	reps = 0;
+	prop_symbol = '\0';
+	prop_increase = false;
+	conn_from = 0;
+	conn_weight = 0.0;
+	neuclass = NULL;
+}
+
+f4_Node::~f4_Node()
+{
+	destroy();
+}
+
+void f4_Node::print_tree(const f4_Node *root, int indent)
+{
+	for (int i = 0; i < indent; i++) printf(" ");
+	printf("%s (%d)", root->name.c_str(), root->count());
+	if (root->name == "[")
+		printf("     from=%-3d  weight=%g", root->conn_from, root->conn_weight);
+	printf("\n");
+	if (root->child) print_tree(root->child, indent + 1);
+	if (root->child2) print_tree(root->child2, indent + 1);
+}
+
+int f4_Node::addChild(f4_Node *nchi)
+{
+	if (child == NULL)
 	{
 		child = nchi;
 		return 0;
 	}
-	if (NULL == child2)
+	if (child2 == NULL)
 	{
 		child2 = nchi;
@@ -1149,5 +1158,5 @@
 }
 
-int f4_node::removeChild(f4_node *nchi)
+int f4_Node::removeChild(f4_Node *nchi)
 {
 	if (nchi == child2)
@@ -1164,32 +1173,32 @@
 }
 
-int f4_node::childCount()
-{
-	if (NULL != child)
-	{
-		if (NULL != child2) return 2;
+int f4_Node::childCount()
+{
+	if (child != NULL)
+	{
+		if (child2 != NULL) return 2;
 		else return 1;
 	}
 	else
 	{
-		if (NULL != child2) return 1;
+		if (child2 != NULL) return 1;
 		else return 0;
 	}
 }
 
-int f4_node::count()
+int f4_Node::count() const
 {
 	int c = 1;
-	if (NULL != child)  c += child->count();
-	if (NULL != child2) c += child2->count();
+	if (child != NULL)  c += child->count();
+	if (child2 != NULL) c += child2->count();
 	return c;
 }
 
-f4_node* f4_node::ordNode(int n)
+f4_Node* f4_Node::ordNode(int n)
 {
 	int n1;
-	if (0 == n) return this;
+	if (n == 0) return this;
 	n--;
-	if (NULL != child)
+	if (child != NULL)
 	{
 		n1 = child->count();
@@ -1197,5 +1206,5 @@
 		n -= n1;
 	}
-	if (NULL != child2)
+	if (child2 != NULL)
 	{
 		n1 = child2->count();
@@ -1206,5 +1215,5 @@
 }
 
-f4_node* f4_node::randomNode()
+f4_Node* f4_Node::randomNode()
 {
 	int n = count();
@@ -1213,10 +1222,10 @@
 }
 
-f4_node* f4_node::randomNodeWithSize(int mn, int mx)
+f4_Node* f4_Node::randomNodeWithSize(int mn, int mx)
 {
 	// try random nodes, and accept if size in range
 	// limit to maxlim tries
 	int i, n, maxlim;
-	f4_node *nod = NULL;
+	f4_Node *nod = NULL;
 	maxlim = count();
 	for (i = 0; i < maxlim; i++)
@@ -1230,5 +1239,5 @@
 }
 
-void f4_node::sprint(SString& out)
+void f4_Node::sprint(SString& out)
 {
 	char buf2[20];
@@ -1237,68 +1246,48 @@
 	{
 		out += "#";
-		if (i1 != 1)
-		{
-			sprintf(buf2, "%d", i1);
+		sprintf(buf2, "%d", reps);
+		out += buf2;
+	}
+	else {
+		// special case: neuron connection
+		if (name == "[")
+		{
+			out += "[";
+			sprintf(buf2, "%d", conn_from);
 			out += buf2;
-		}
-	}
-	else {
-		// special case: neuron link
-		if (name == "[")
-		{
-			out += "[";
-			if (i1 > 0)
-			{
-				// sensor input
-				out += s1.c_str();
-			}
-			else
-			{
-				sprintf(buf2, "%d", l1);
-				out += buf2;
-			}
-			sprintf(buf2, ":%g]", f1);
+			sprintf(buf2, ":%g]", conn_weight);
 			out += buf2;
 		}
 		else if (name == ":")
 		{
-			sprintf(buf2, ":%c%c:", l1 ? '+' : '-', (char)i1);
+			sprintf(buf2, ":%c%c:", prop_increase ? '+' : '-', prop_symbol);
 			out += buf2;
 		}
-		else if (name == "@" || name == "|")
-		{
-			if (parent->name == "N")
-			{
-				out += name.c_str();
-			}
-			else
-			{
-				out += "N:";
-				out += name.c_str();
-			}
+		else if (neuclass != NULL)
+		{
+			out += "N:";
+			out += neuclass->name.c_str();
 		}
 		else
 		{
-			char *temp = (char*)name.c_str();
-			NeuroClass *nc = GenoOperators::parseNeuroClass(temp);
-			if (nc != NULL)
-			{
-				out += "N:";
-			}
 			out += name.c_str();
 		}
 	}
-	if (NULL != child)     child->sprint(out);
+
+	if (child != NULL)
+		child->sprint(out);
 	// if two children, make sure last char is a '>'
-	if (2 == childCount())
-		if (0 == out[0]) out += ">"; else
-			if ('>' != out[out.length() - 1]) out += ">";
-	if (NULL != child2)    child2->sprint(out);
+	if (childCount() == 2)
+		if (out[0] == 0) out += ">"; else
+			if (out[out.length() - 1] != '>') out += ">";
+
+	if (child2 != NULL)
+		child2->sprint(out);
 	// make sure last char is a '>'
-	if (0 == out[0]) out += ">"; else
-		if ('>' != out[out.length() - 1]) out += ">";
-}
-
-void f4_node::sprintAdj(char *& buf)
+	if (out[0] == 0) out += ">"; else
+		if (out[out.length() - 1] != '>') out += ">";
+}
+
+void f4_Node::sprintAdj(char *& buf)
 {
 	unsigned int len;
@@ -1312,5 +1301,5 @@
 	len = out.length();
 	if (len > 1)
-		if ('>' == out[len - 1]) { (out.directWrite())[len - 1] = 0; out.endWrite(); };
+		if (out[len - 1] == '>') { (out.directWrite())[len - 1] = 0; out.endWrite(); };
 	// copy back to string
 	// if new is longer, reallocate buf
@@ -1322,17 +1311,17 @@
 }
 
-f4_node* f4_node::duplicate()
-{
-	f4_node *copy;
-	copy = new f4_node(*this);
+f4_Node* f4_Node::duplicate()
+{
+	f4_Node *copy;
+	copy = new f4_Node(*this);
 	copy->parent = NULL;  // set later
 	copy->child = NULL;
 	copy->child2 = NULL;
-	if (NULL != child)
+	if (child != NULL)
 	{
 		copy->child = child->duplicate();
 		copy->child->parent = copy;
 	}
-	if (NULL != child2)
+	if (child2 != NULL)
 	{
 		copy->child2 = child2->duplicate();
@@ -1343,23 +1332,19 @@
 
 
-void f4_node::destroy()
+void f4_Node::destroy()
 {
 	// children are destroyed (recursively) through the destructor
-	if (NULL != child2)  delete child2;
-	if (NULL != child)   delete child;
+	if (child2 != NULL) delete child2;
+	if (child != NULL) delete child;
 }
 
 // scan genotype string and build tree
 // return >1 for error (errorpos)
-int f4_processrec(const char* genot, unsigned pos0, f4_node *parent)
-{
-	int i, j, res, t;
-	char tc1, tc2, tc3[2]; // tc3 is only to ensure that neuron parameter definition is completed
-	int relfrom;
-	double w;
+int f4_processrec(const char* genot, unsigned pos0, f4_Node *parent)
+{
+	int i, res;
 	unsigned gpos, oldpos;
-	f4_node *node1, *par;
+	f4_Node *node1, *par;
 	unsigned beginindex;
-	string neutype = "";
 
 	gpos = pos0;
@@ -1368,5 +1353,4 @@
 	while (gpos < strlen(genot))
 	{
-		neutype = "";
 		// first switch across cell dividers and old semantics
 		switch (genot[gpos])
@@ -1375,7 +1359,7 @@
 		{
 			// find out genotype start for child
-			j = scanrec(genot + gpos + 1, strlen(genot + gpos + 1), '>');
-
-			node1 = new f4_node("<", par, gpos);
+			int j = scanrec(genot + gpos + 1, strlen(genot + gpos + 1), '>');
+
+			node1 = new f4_Node("<", par, gpos);
 			par = node1;
 			res = f4_processrec(genot, gpos + 1, par);
@@ -1388,5 +1372,5 @@
 			else // ran out
 			{
-				node1 = new f4_node(">", par, int(strlen(genot)) - 1);
+				node1 = new f4_Node(">", par, int(strlen(genot)) - 1);
 				par = node1;
 			}
@@ -1396,7 +1380,7 @@
 		case '>':
 		{
-			node1 = new f4_node(">", par, gpos);
+			node1 = new f4_Node(">", par, gpos);
 			par = node1;
-			gpos = strlen(genot);
+			gpos = (unsigned int)strlen(genot);
 			return 0;  // OK
 		}
@@ -1409,12 +1393,12 @@
 			else i = val.getInt();
 			// find out genotype start for continuation
-			j = scanrec(genot + gpos + 1, strlen(genot + gpos + 1), '>');
+			int j = scanrec(genot + gpos + 1, strlen(genot + gpos + 1), '>');
 			// skip number
 			oldpos = gpos;
 			gpos += end - (genot + gpos);
 			//gpos++;
-			//while ((genot[gpos] >= '0') && (genot[gpos] <= '9')) gpos++;node1 = new f4_node("#", par, oldpos);
-			node1 = new f4_node("#", par, oldpos);
-			node1->i1 = i;
+			//while ((genot[gpos] >= '0') && (genot[gpos] <= '9')) gpos++;node1 = new f4_Node("#", par, oldpos);
+			node1 = new f4_Node("#", par, oldpos);
+			node1->reps = i;
 			par = node1;
 			res = f4_processrec(genot, gpos, node1);
@@ -1427,5 +1411,5 @@
 			else // ran out
 			{
-				node1 = new f4_node(">", par, int(strlen(genot)) - 1);
+				node1 = new f4_Node(">", par, int(strlen(genot)) - 1);
 			}
 			return 0;  // OK
@@ -1440,122 +1424,71 @@
 			break;
 		}
-		case 'l':  case 'L':
-		case 'c':  case 'C':
-		case 'q':  case 'Q':
-		case 'r':  case 'R':
-		case 'X':  case ',':
-		case 'a':  case 'A':
-		case 's':  case 'S':
-		case 'm':  case 'M':
-		case 'i':  case 'I':
-		case 'f':  case 'F':
-		case 'w':  case 'W':
-		case 'e':  case 'E':
-		{
-			node1 = new f4_node(genot[gpos], par, gpos);
+		case 'N':
+		{
+			int forgenorange = gpos;
+			if (genot[gpos + 1] != ':')
+				return gpos + 1; //error
+			gpos += 2; //skipping "N:"
+			beginindex = gpos;
+			char* end = (char*)genot + beginindex;
+			NeuroClass *neuclass = GenoOperators::parseNeuroClass(end, ModelEnum::SHAPETYPE_BALL_AND_STICK);
+			if (neuclass == NULL)
+				return gpos + 1; //error
+			gpos += end - genot - beginindex;
+			string neutype = string(genot + beginindex, genot + gpos);
+			node1 = new f4_Node(neutype, par, forgenorange);
+			node1->neuclass = neuclass;
+			par = node1;
+			// if it continues with a colon that determines a neuron parameter (e.g. N:N:+=: ), then let the switch case for colon handle this
+			break;
+		}
+		case ':':
+		{
+			// neuron parameter  +! -! += -= +/ or -/
+			// in the future this could be generalized to all neuron properties, for example N:|:power:0.6:range:1.4, or can even use '=' or ',' instead of ':' if no ambiguity
+			char prop_dir, prop_symbol, prop_end[2]; // prop_end is only to ensure that neuron parameter definition is completed
+			if (sscanf(genot + gpos, ":%c%c%1[:]", &prop_dir, &prop_symbol, &prop_end) != 3)
+				// error: incorrect format
+				return gpos + 1 + 1;
+			if (prop_dir != '-' && prop_dir != '+')
+				return gpos + 1 + 1; //error
+			switch (prop_symbol)
+			{
+			case '!':  case '=':  case '/':  break;
+			default:
+				return gpos + 1 + 1; //error
+			}
+			node1 = new f4_Node(":", par, gpos);
+			node1->prop_symbol = prop_symbol;
+			node1->prop_increase = prop_dir == '+' ? true : false; // + or -
+			par = node1;
+			int chars = scanrec(genot + gpos + 1, strlen(genot + gpos + 1), ':');
+			gpos += chars + 2;
+			break;
+		}
+		case '[':
+		{
+			double weight = 0;
+			int relfrom;
+			const char *end = parseConnection(genot + gpos, relfrom, weight);
+			if (end == NULL)
+				return gpos + 1; //error
+
+			node1 = new f4_Node("[", par, gpos);
+			node1->conn_from = relfrom;
+			node1->conn_weight = weight;
+			par = node1;
+			int j = scanrec(genot + gpos + 1, strlen(genot + gpos + 1), ']');
+			gpos += j + 2;
+			break;
+		}
+		default: // 'X' and ',' and all modifiers and also invalid symbols - add a node, for invalid symbols build will give the error or repair
+		{
+			//printf("any regular character '%c'\n", genot[gpos]);
+			node1 = new f4_Node(genot[gpos], par, gpos);
 			par = node1;
 			gpos++;
 			break;
 		}
-		case '@':  case '|':
-		{
-			// in order to prevent the presence of "free muscles", we need to ensure that a muscle is written as N@/N| or N:@/N:|
-			if (par != NULL && par->name == "N")
-			{
-				node1 = new f4_node(genot[gpos], par, gpos);
-				par = node1;
-				gpos++;
-			}
-			else
-			{
-				return gpos + 1;
-			}
-			break;
-		}
-
-		case 'N':
-		{
-			// if there is no colon after N, then there is no class definition
-			if (gpos + 1 >= strlen(genot) || genot[gpos + 1] != ':')
-			{
-				node1 = new f4_node(genot[gpos], par, gpos);
-				par = node1;
-				gpos++;
-				break;
-			}
-			// if there is a colon determining neuron parameter, then let the switch case colon handle this
-			else if (sscanf(genot + gpos + 1, ":%c%c%1[:]", &tc1, &tc2, &tc3) == 3)
-			{
-				node1 = new f4_node(genot[gpos], par, gpos);
-				par = node1;
-				gpos++;
-				break;
-			}
-			int forgenorange = gpos;
-			gpos += 2; //skipping "N:"
-			beginindex = gpos;
-			char* end = (char*)genot + beginindex;
-			GenoOperators::parseNeuroClass(end);
-			gpos += end - genot - beginindex;
-			neutype = string(genot + beginindex, genot + gpos);
-			node1 = new f4_node(neutype, par, forgenorange);
-			par = node1;
-			break;
-		}
-		case ':':
-		{
-			// neuron parameter  +! -! += -= +/ or -/
-			if (sscanf(genot + gpos, ":%c%c%1[:]", &tc1, &tc2, &tc3) != 3)
-				// error: incorrect format
-				return gpos + 1 + 1;
-			if ('+' == tc1) j = 1;
-			else if ('-' == tc1) j = 0;
-			else return gpos + 1 + 1;
-			switch (tc2)
-			{
-			case '!':  case '=':  case '/':  break;
-			default:
-				return gpos + 1 + 1;
-			}
-			node1 = new f4_node(":", par, gpos);
-			node1->l1 = j;
-			node1->i1 = (int)tc2;
-			par = node1;
-			j = scanrec(genot + gpos + 1, strlen(genot + gpos + 1), ':');
-			gpos += j + 2;
-			break;
-		}
-		case '[':
-		{
-			const char *end = parseConnection(genot + gpos, relfrom, w);
-			if (end == NULL)
-			{
-				end = parseConnectionWithNeuron(genot + gpos, neutype, w);
-				if (end == NULL) t = -1;
-				else t = 1;
-			}
-			else
-			{
-				t = 0;
-			}
-			node1 = new f4_node("[", par, gpos);
-			node1->s1 = neutype;
-			node1->i1 = t;
-			node1->l1 = relfrom;
-			node1->f1 = w;
-			par = node1;
-			j = scanrec(genot + gpos + 1, strlen(genot + gpos + 1), ']');
-			gpos += j + 2;
-			break;
-		}
-		default:
-		{
-			//DB( printf("unknown character '%c' ! \n", genot[gpos]); )
-			//add it, build will give the error or repair
-			node1 = new f4_node(genot[gpos], par, gpos);
-			par = node1;
-			gpos++;
-			break;
-		}
 		}
 	}
@@ -1566,5 +1499,5 @@
 		if (par->name != ">")
 		{
-			node1 = new f4_node('>', par, int(strlen(genot)) - 1);
+			node1 = new f4_Node('>', par, int(strlen(genot)) - 1);
 			par = node1;
 		}
@@ -1593,30 +1526,8 @@
 }
 
-const char* parseConnectionWithNeuron(const char *fragm, string &neutype, double &weight)
-{
-	const char *parser = fragm;
-	if (*parser != '[') return NULL;
-	parser++;
-	char* p = (char*)parser;
-	if (GenoOperators::parseNeuroClass(p) == NULL) return NULL;
-	neutype = string(parser, (const char *)p);
-	parser = p;
-	if (*parser != ':') return NULL;
-	parser++;
-	ExtValue val;
-	parser = val.parseNumber(parser, ExtPType::TDouble);
-	if (parser == NULL) return NULL;
-	weight = val.getDouble();
-	if (*parser != ']') return NULL;
-	parser++;
-	return parser;
-}
-
-f4_node* f4_processtree(const char* geno)
-{
-	f4_node *root;
-	int res;
-	root = new f4_node();
-	res = f4_processrec(geno, 0, root);
+f4_Node* f4_processtree(const char* geno)
+{
+	f4_Node *root = new f4_Node();
+	int res = f4_processrec(geno, 0, root);
 	if (res) return NULL;
 	//DB( printf("test f4  "); )
